#include "Renderer.h"
#include "../Scene/Components.h"
#include <glad/glad.h>

float Angle = 0.0;
Camera cam = Camera(glm::vec3(16.0f, 0.0f, 0.0f), glm::vec3(0.0f, 0.0f, 0.0f), 90.0f);
glm::mat4 projection = glm::perspective(glm::radians(cam.Zoom), (800.0f / 600.0f), 0.001f, 100.0f);

BarinkEngine::Renderer::Renderer()
{
}

BarinkEngine::Renderer::~Renderer()
{
}


void BarinkEngine::Renderer::Render(Scene& scene)
{
	auto group = scene.getReg().view<TransformComponent, Render3DComponent>();
	group.each([](auto entity , TransformComponent& trans, Render3DComponent& render) 
		{
		glBindVertexArray(render.VAO);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, render.IBO);

		render.shader.Use();

		render.shader.setUniformVec3("Color", render.color);

		render.shader.setUniformMat4("M", glm::mat4(1.0f));
		render.shader.setUniformMat4("V", cam.GetViewMatrix());
		render.shader.setUniformMat4("P", projection);


		glDrawElements(GL_TRIANGLES, render.ElementCount,
			GL_UNSIGNED_INT, NULL);

		glBindVertexArray(0);
	});

}



void Render(Framebuffer& framebuffer) {

}